#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
# $Id: copfilter.cgi,v 0.00.0.3 2005/03/15 mmadlener
#

# Add entry in menu
# MENUENTRY copfilter 050 "SMTP Filter" "copfilter smtp"

#
# Make sure translation exists $Lang::tr{'copfilter smtp'}


use strict;
use IO::Socket;
# enable only the following on debugging purpose
#use warnings;
#use CGI::Carp 'fatalsToBrowser';



################################################################################
##   Definitions
################################################################################

require '/usr/lib/ipcop/general-functions.pl';
require "/usr/lib/ipcop/lang.pl";
require "/usr/lib/ipcop/header.pl";

my ($copfilter_swroot);
my %copfiltersettings=();
my %netsettings=();
my (%selected,%checked)=();
my $errormessage = '';
my $output = '';
my $netsettings = ();
my $i;
$copfiltersettings{'ACTION'} = '';


$copfilter_swroot = '/var/log/copfilter/default';
&General::readhash("/var/ipcop/ethernet/settings", \%netsettings);
&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);
#&General::writehash("/tmp/before_cgi", \%copfiltersettings);
$copfiltersettings{'SKIP_RESTART'}='off';
&General::getcgihash(\%copfiltersettings);

#testing
#my %copfiltersettings2=();
#&General::readhash("${copfilter_swroot}/etc/global_settings", \%copfiltersettings3);
#&Header::getcgihash(\%copfiltersettings2);
#&General::writehash("/tmp/after_cgi", \%copfiltersettings);
#&General::writehash("/tmp/cgi", \%copfiltersettings2);


&Header::showhttpheaders();
&Header::openpage('Copfilter', 1, '');


#sub copfilter_set_lang {

package Lang;

### Initialize language
%Lang::tr = ();
    our $language;
    my %settings = ();
    &General::readhash("/var/ipcop/main/settings", \%settings);
    $language = $settings{'LANGUAGE'};
    if ($language =~ /^(\w+)$/) {$language = $1;}
    do "${copfilter_swroot}/langs/en.pl";
    do "${copfilter_swroot}/langs/${language}.pl";
1;
#}
#
#copfilter_set_lang();






################################################################################
##   Substitutions
################################################################################


sub copfilter_start_log
{

	&Header::openbigbox('100%', 'left');
	&Header::openbox('100%', 'left', "$Lang::tr{'copfilter'}:");
	print "<H1>  $Lang::tr{'copfilter log'}: </H1>\n";
}

sub copfilter_stop_log
{
        print "<br /><br />";
        #system('echo "<A HREF=$HTTP_REFERER> Back to the copfilter configuration page </A>"');
        print "<A HREF='/cgi-bin/copfilter_smtp.cgi' > $Lang::tr{'copfilter back'} </A>\n";
        print "<br /><br />";

        &Header::closebox();
        &Header::closebigbox();
        &Header::closepage();
}


sub writehashsorted
{
        my $filename = $_[0];
        my $hash = $_[1];
        my ($var, $val);


        # write cgi vars to the file.
        open(FILE, ">${filename}") or die "Unable to write file $filename";
        flock FILE, 2;
        foreach $var (sort (keys %$hash))
        {
                $val = $hash->{$var};
                # Darren Critchley Jan 17, 2003 added the following because when submitting with a graphic, the x and y
                # location of the mouse are submitted as well, this was being written to the settings file causing
                # some serious grief! This skips the variable.x and variable.y
                if (!($var =~ /(.x|.y)$/)) {
                        if ($val =~ / /) {
                                $val = "\'$val\'"; }
                        if (!($var =~ /^ACTION/)) {
                                print FILE "${var}=${val}\n"; }
                }
        }
        close FILE;
}


sub downloadver
{
        my %proxysettings=();
        &General::readhash("/var/ipcop/proxy/settings", \%proxysettings);

        my $peer = 'www.copfilter.org';
        my $peerport = 80;

        if ($_=$proxysettings{'UPSTREAM_PROXY'}) {
        ($peer, $peerport) = (/^(?:[a-zA-Z ]+\:\/\/)?(?:[A-Za-z0-9\_\.\-]*?(?:\:[A-Za-z0-9\_\.\-]*?)?\@)?([a-zA-Z0-9\.\_\-]*?)(?:\:([0-9]{1,5}))?(?:\/.*?)?$/);
        }

        my $sock=();
        unless($sock = new IO::Socket::INET (PeerAddr => $peer, PeerPort => $peerport, Proto => 'tcp', Timeout => 5))
        {
                return 0;
        }


        my $GET_CMD;
        $GET_CMD  = "GET http://www.copfilter.org/LATEST-VERSION-V2 HTTP/1.1\r\n";
        $GET_CMD .= "Host: www.copfilter.org\r\n";
        $GET_CMD .= "Cache-Control: no-cache\r\n";
        $GET_CMD .= "Connection: close\r\n\r\n";
        print $sock "$GET_CMD";

        my $ret = '';
        while (<$sock>) {
                $ret .= $_; }
        close($sock);
        return $ret;
}



################################################################################
##   SMTP
################################################################################

######### SMTP_SCAN_GREEN
$selected{'SMTP_SCAN_GREEN'}{'off'} = '';
$selected{'SMTP_SCAN_GREEN'}{'on'} = '';
$selected{'SMTP_SCAN_GREEN'}{$copfiltersettings{'SMTP_SCAN_GREEN'}} = "selected='selected'";

######### SMTP_SCAN_ORANGE
$selected{'SMTP_SCAN_ORANGE'}{'off'} = '';
$selected{'SMTP_SCAN_ORANGE'}{'on'} = '';
$selected{'SMTP_SCAN_ORANGE'}{$copfiltersettings{'SMTP_SCAN_ORANGE'}} = "selected='selected'";

######### SMTP_SCAN_BLUE
$selected{'SMTP_SCAN_BLUE'}{'off'} = '';
$selected{'SMTP_SCAN_BLUE'}{'on'} = '';
$selected{'SMTP_SCAN_BLUE'}{$copfiltersettings{'SMTP_SCAN_BLUE'}} = "selected='selected'";

######### SMTP_SCAN_RED
$selected{'SMTP_SCAN_RED'}{'off'} = '';
$selected{'SMTP_SCAN_RED'}{'on'} = '';
$selected{'SMTP_SCAN_RED'}{$copfiltersettings{'SMTP_SCAN_RED'}} = "selected='selected'";

######### SMTP_VIRUS_SCAN
$selected{'SMTP_VIRUS_SCAN'}{'off'} = '';
$selected{'SMTP_VIRUS_SCAN'}{'on'} = '';
$selected{'SMTP_VIRUS_SCAN'}{$copfiltersettings{'SMTP_VIRUS_SCAN'}} = "selected='selected'";

######### SMTP_VIRUS_SCAN_ATTACHMENT
$selected{'SMTP_VIRUS_SCAN_ATTACHMENT'}{'off'} = '';
$selected{'SMTP_VIRUS_SCAN_ATTACHMENT'}{'on'} = '';
$selected{'SMTP_VIRUS_SCAN_ATTACHMENT'}{$copfiltersettings{'SMTP_VIRUS_SCAN_ATTACHMENT'}} = "selected='selected'";

######### SMTP_SPAM_QUARANTINE
$selected{'SMTP_SPAM_QUARANTINE'}{'off'} = '';
$selected{'SMTP_SPAM_QUARANTINE'}{'on'} = '';
$selected{'SMTP_SPAM_QUARANTINE'}{$copfiltersettings{'SMTP_SPAM_QUARANTINE'}} = "selected='selected'";

######### SMTP_SPAM_QUARANTINE_NOTIFY_USER
$selected{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}{'off'} = '';
$selected{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}{'on'} = '';
$selected{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}{$copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}} = "selected='selected'";

######### SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL
for(my $i = 1; $i <= 40; $i++)
{
   $selected{'SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'}{$i} = '';
}
$selected{'SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'}{$copfiltersettings{'SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'}} = "selected='selected'";

######### SMTP_VIRUS_QUARANTINE
$selected{'SMTP_VIRUS_QUARANTINE'}{'off'} = '';
$selected{'SMTP_VIRUS_QUARANTINE'}{'on'} = '';
$selected{'SMTP_VIRUS_QUARANTINE'}{$copfiltersettings{'SMTP_VIRUS_QUARANTINE'}} = "selected='selected'";

######### SMTP_VIRUS_NOTIFY_USER
$selected{'SMTP_VIRUS_NOTIFY_USER'}{'off'} = '';
$selected{'SMTP_VIRUS_NOTIFY_USER'}{'on'} = '';
$selected{'SMTP_VIRUS_NOTIFY_USER'}{$copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'}} = "selected='selected'";

######### SMTP_ATTACHMENT_SCAN
$selected{'SMTP_ATTACHMENT_SCAN'}{'off'} = '';
$selected{'SMTP_ATTACHMENT_SCAN'}{'on'} = '';
$selected{'SMTP_ATTACHMENT_SCAN'}{$copfiltersettings{'SMTP_ATTACHMENT_SCAN'}} = "selected='selected'";

######### SMTP_SPAM_SCAN
$selected{'SMTP_SPAM_SCAN'}{'off'} = '';
$selected{'SMTP_SPAM_SCAN'}{'on'} = '';
$selected{'SMTP_SPAM_SCAN'}{$copfiltersettings{'SMTP_SPAM_SCAN'}} = "selected='selected'";

######### SPAM_SCAN_SCORE_LEVEL
for(my $i = 1; $i <= 40; $i++)
{
   $selected{'SPAM_SCAN_SCORE_LEVEL'}{$i} = '';
}
$selected{'SPAM_SCAN_SCORE_LEVEL'}{$copfiltersettings{'SPAM_SCAN_SCORE_LEVEL'}} = "selected='selected'";

########## SMTP_VIRUS_SCAN_BOUNCE
#$selected{'SMTP_VIRUS_SCAN_BOUNCE'}{'off'} = '';
#$selected{'SMTP_VIRUS_SCAN_BOUNCE'}{'on'} = '';
#$selected{'SMTP_VIRUS_SCAN_BOUNCE'}{$copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'}} = "selected='selected'";
#
########## SMTP_ATTACHMENT_SCAN_BOUNCE
#$selected{'SMTP_ATTACHMENT_SCAN_BOUNCE'}{'off'} = '';
#$selected{'SMTP_ATTACHMENT_SCAN_BOUNCE'}{'on'} = '';
#$selected{'SMTP_ATTACHMENT_SCAN_BOUNCE'}{$copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'}} = "selected='selected'";
#
########## SMTP_SPAM_SCAN_BOUNCE
#$selected{'SMTP_SPAM_SCAN_BOUNCE'}{'off'} = '';
#$selected{'SMTP_SPAM_SCAN_BOUNCE'}{'on'} = '';
#$selected{'SMTP_SPAM_SCAN_BOUNCE'}{$copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'}} = "selected='selected'";
#
########## SMTP_SPAM_SCAN_BOUNCE_SCORE_LEVEL
#for(my $i = 1; $i <= 40; $i++)
#{
#   $selected{'SMTP_SPAM_SCAN_BOUNCE_SCORE_LEVEL'}{$i} = '';
#}
#$selected{'SMTP_SPAM_SCAN_BOUNCE_SCORE_LEVEL'}{$copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE_SCORE_LEVEL'}} = "selected='selected'";

######### SMTP_VIRUS_SCAN_DISCARD
$selected{'SMTP_VIRUS_SCAN_DISCARD'}{'off'} = '';
$selected{'SMTP_VIRUS_SCAN_DISCARD'}{'on'} = '';
$selected{'SMTP_VIRUS_SCAN_DISCARD'}{$copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'}} = "selected='selected'";

######### SMTP_ATTACHMENT_SCAN_DISCARD
$selected{'SMTP_ATTACHMENT_SCAN_DISCARD'}{'off'} = '';
$selected{'SMTP_ATTACHMENT_SCAN_DISCARD'}{'on'} = '';
$selected{'SMTP_ATTACHMENT_SCAN_DISCARD'}{$copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'}} = "selected='selected'";

######### SMTP_SPAM_SCAN_DISCARD
$selected{'SMTP_SPAM_SCAN_DISCARD'}{'off'} = '';
$selected{'SMTP_SPAM_SCAN_DISCARD'}{'on'} = '';
$selected{'SMTP_SPAM_SCAN_DISCARD'}{$copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'}} = "selected='selected'";

######### SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL
for(my $i = 1; $i <= 40; $i++)
{
   $selected{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}{$i} = '';
}
$selected{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}{$copfiltersettings{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}} = "selected='selected'";

######### SMTP_SANITIZE_SCAN
$selected{'SMTP_SANITIZE_SCAN'}{'off'} = '';
$selected{'SMTP_SANITIZE_SCAN'}{'on'} = '';
$selected{'SMTP_SANITIZE_SCAN'}{$copfiltersettings{'SMTP_SANITIZE_SCAN'}} = "selected='selected'";

######### SMTP_AUTH_ENABLE
$selected{'SMTP_AUTH_ENABLE'}{'off'} = '';
$selected{'SMTP_AUTH_ENABLE'}{'on'} = '';
$selected{'SMTP_AUTH_ENABLE'}{$copfiltersettings{'SMTP_AUTH_ENABLE'}} = "selected='selected'";

######### SMTP_MAIL_REWRITE_SUBJECT
$selected{'SMTP_MAIL_REWRITE_SUBJECT'}{'off'} = '';
$selected{'SMTP_MAIL_REWRITE_SUBJECT'}{'on'} = '';
$selected{'SMTP_MAIL_REWRITE_SUBJECT'}{$copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'}} = "selected='selected'";

######### SMTP_MAIL_ADD_HEADER
$selected{'SMTP_MAIL_ADD_HEADER'}{'off'} = '';
$selected{'SMTP_MAIL_ADD_HEADER'}{'on'} = '';
$selected{'SMTP_MAIL_ADD_HEADER'}{$copfiltersettings{'SMTP_MAIL_ADD_HEADER'}} = "selected='selected'";

######### SMTP_MAIL_ADD_BODY
$selected{'SMTP_MAIL_ADD_BODY'}{'off'} = '';
$selected{'SMTP_MAIL_ADD_BODY'}{'on'} = '';
$selected{'SMTP_MAIL_ADD_BODY'}{$copfiltersettings{'SMTP_MAIL_ADD_BODY'}} = "selected='selected'";

######### SMTP_VIRUS_ADMINNOTIF
$selected{'SMTP_VIRUS_ADMINNOTIF'}{'off'} = '';
$selected{'SMTP_VIRUS_ADMINNOTIF'}{'on'} = '';
$selected{'SMTP_VIRUS_ADMINNOTIF'}{$copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'}} = "selected='selected'";

######### SMTP_SPAM_WHITELIST
$selected{'SMTP_SPAM_WHITELIST'}{'off'} = '';
$selected{'SMTP_SPAM_WHITELIST'}{'on'} = '';
$selected{'SMTP_SPAM_WHITELIST'}{$copfiltersettings{'SMTP_SPAM_WHITELIST'}} = "selected='selected'";


######### MAIL_SRV_LOCATION
$selected{'MAIL_SRV_LOCATION'}{'GREEN'} = '';
$selected{'MAIL_SRV_LOCATION'}{'ORANGE'} = '';
$selected{'MAIL_SRV_LOCATION'}{$copfiltersettings{'MAIL_SRV_LOCATION'}} = "selected='selected'";

######### WHITELIST_OUTGOING_EMAIL
$selected{'WHITELIST_OUTGOING_EMAIL'}{'off'} = '';
$selected{'WHITELIST_OUTGOING_EMAIL'}{'on'} = '';
$selected{'WHITELIST_OUTGOING_EMAIL'}{$copfiltersettings{'WHITELIST_OUTGOING_EMAIL'}} = "selected='selected'";

######### WHITELIST_OUTGOING_EMAIL_QUARANTINE
$selected{'WHITELIST_OUTGOING_EMAIL_QUARANTINE'}{'off'} = '';
$selected{'WHITELIST_OUTGOING_EMAIL_QUARANTINE'}{'on'} = '';
$selected{'WHITELIST_OUTGOING_EMAIL_QUARANTINE'}{$copfiltersettings{'WHITELIST_OUTGOING_EMAIL_QUARANTINE'}} = "selected='selected'";

######### CP_WH_CMD_MODE
$selected{'CP_WH_CMD_MODE'}{'off'} = '';
$selected{'CP_WH_CMD_MODE'}{'on'} = '';
$selected{'CP_WH_CMD_MODE'}{$copfiltersettings{'CP_WH_CMD_MODE'}} = "selected='selected'";


######### DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL
$selected{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}{'off'} = '';
$selected{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}{'on'} = '';
$selected{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}{$copfiltersettings{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}} = "selected='selected'";

######### REDIP_ALIAS_ETHERNET_INTERFACE
$selected{'REDIP_ALIAS_ETHERNET_INTERFACE'}{'off'} = '';
$selected{'REDIP_ALIAS_ETHERNET_INTERFACE'}{'on'} = '';
$selected{'REDIP_ALIAS_ETHERNET_INTERFACE'}{$copfiltersettings{'REDIP_ALIAS_ETHERNET_INTERFACE'}} = "selected='selected'";

######### SMTP_GREYLISTING
$selected{'SMTP_GREYLISTING'}{'off'} = '';
$selected{'SMTP_GREYLISTING'}{'on'} = '';
$selected{'SMTP_GREYLISTING'}{$copfiltersettings{'SMTP_GREYLISTING'}} = "selected='selected'";

######### REJECT_INSTEAD_OF_DISCARD_EMAIL
$selected{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}{'off'} = '';
$selected{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}{'on'} = '';
$selected{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}{$copfiltersettings{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}} = "selected='selected'";


################################################################################
##   ACTIONs
################################################################################



######### PROXSMTPD DEBUG
if (    $copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter start proxsmtpd debug'} )
{
        &copfilter_start_log();
        print "<br /><b>$Lang::tr{'copfilter restart0'} proxsmtpd $Lang::tr{'copfilter in debug'}</b> <br />";
        system('/usr/local/bin/copfilter_restartproxsmtpd_debug');
        &copfilter_stop_log();
}




######### Save settings

if ($copfiltersettings{'ACTION'} eq $Lang::tr{'copfilter save'})
{ 

################################################################################
##   Checking input values
################################################################################

	if ($copfiltersettings{'IMSPECTOR_PROXY_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMSPECTOR_PROXY_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SPAM_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'POP3_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SCAN_RED'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_ATTACHMENT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_QUARANTINE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_NOTIFY_USER'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_VIRUS_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_ATTACHMENT_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'SMTP_SPAM_SCAN_BOUNCE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_SANITIZE_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_AUTH_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DEBUG'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'IMAP_DAILY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_REWRITE_SUBJECT'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_HEADER'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_MAIL_ADD_BODY'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'SPAM_SCAN_SPEEDUP'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'PRIVOXY_ENABLE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
#	    $copfiltersettings{'HTTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'HTTP_VIRUS_SCAN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'MONIT_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_GREEN'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_ORANGE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FTP_SCAN_BLUE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'CLAMD_ENABLE'} !~ /^(on|off)$/ || 
	    $copfiltersettings{'FPROT_ENABLE'} !~ /^(on|off)$/ ) 
        {
            $errormessage = $Lang::tr{'copfilter invalid input'};
            goto ERROR;
        } 


        if ($copfiltersettings{'MAILSERVER'} ne '' && $copfiltersettings{'MAILSERVER_PORT'} eq '' )
        {
                $errormessage = $Lang::tr{'copfilter invalid mailserver port'};
                goto ERROR;
        }

        if ($copfiltersettings{'RED_IP_ALIAS'} ne '' && $copfiltersettings{'SMTP_SCAN_RED'} eq 'on' )
        {
                if ( ! ( &General::validip($copfiltersettings{'RED_IP_ALIAS'}) ) )
                {
                        $errormessage = $Lang::tr{'copfilter invalid redip_alias'};
                        goto ERROR;
                }
        }

        if ($copfiltersettings{'ALLOW_MAIL_ONLY_FROM_IP'} ne '' && $copfiltersettings{'SMTP_SCAN_RED'} eq 'on' )
        {
                if ( ! ( &General::validip($copfiltersettings{'ALLOW_MAIL_ONLY_FROM_IP'}) ) )
                {
                        $errormessage = $Lang::tr{'copfilter invalid allow_mail_only_from_ip'};
                        goto ERROR;
                }
        }

        if ($copfiltersettings{'MAILSERVER'} eq '' && $copfiltersettings{'SMTP_SCAN_RED'} eq 'on' )
        {
                $errormessage = $Lang::tr{'copfilter missing mailserver'};
                goto ERROR;

        }

        if ($copfiltersettings{'MAILSERVER'} ne '' && $copfiltersettings{'SMTP_SCAN_RED'} eq 'on' )
        {
                if ( ! ( &General::validfqdn($copfiltersettings{'MAILSERVER'}) || &General::validip($copfiltersettings{'MAILSERVER'}) ) )
                {
                        $errormessage = $Lang::tr{'copfilter invalid mailserver'};
                        goto ERROR;
                }
        }


        if (!($copfiltersettings{'SMTP_VIRUS_QUARANTINE_REMOVAL_DAYS'} =~ /^\d+$/) || $copfiltersettings{'SMTP_VIRUS_QUARANTINE_REMOVAL_DAYS'} <= 0)
        {
                $errormessage = $Lang::tr{'copfilter invalid smtp quarantine timeperiod'};
                goto ERROR;
        }



        if ( $copfiltersettings{'SMTP_VIRUS_SCAN_DISCARD'} eq 'on' && $copfiltersettings{'SMTP_VIRUS_ADMINNOTIF'} eq 'on')
        {
                $errormessage = $Lang::tr{'copfilter virus_discard_and_adminnotif'};
                goto ERROR;
        }
      


ERROR:
#print "<H1>lkj</H1>";
#print "$copfiltersettings{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}";
	if ($errormessage) {
		$copfiltersettings{'VALID'} = 'no'; }
	else {
        $copfiltersettings{'VALID'} = 'yes'; }



################################################################################
##   set update values
################################################################################




################################################################################
##   purge enable and update files
################################################################################



	if ($copfiltersettings{'VALID'} eq 'yes')
	{

	    unlink "${copfilter_swroot}/etc/proxsmtpd_enable";

            if ( $copfiltersettings{'SMTP_SCAN_GREEN'} eq 'on' || 
                 $copfiltersettings{'SMTP_SCAN_ORANGE'} eq 'on' || 
                 $copfiltersettings{'SMTP_SCAN_BLUE'} eq 'on'  ||
                 $copfiltersettings{'SMTP_SCAN_RED'} eq 'on' ) {
			system ('/usr/bin/touch', "${copfilter_swroot}/etc/proxsmtpd_enable"); }


            if ( ($copfiltersettings{'POP3_SPAM_SCAN'}   eq 'on'    && 
                 ($copfiltersettings{'POP3_SCAN_GREEN'}  eq 'on'    || 
                  $copfiltersettings{'POP3_SCAN_ORANGE'} eq 'on  '  ||
                  $copfiltersettings{'POP3_SCAN_BLUE'}   eq 'on' )) || 
                 ($copfiltersettings{'SMTP_SPAM_SCAN'}   eq 'on'    && 
                 ($copfiltersettings{'SMTP_SCAN_GREEN'}  eq 'on'    || 
                  $copfiltersettings{'SMTP_SCAN_ORANGE'} eq 'on'    ||
                  $copfiltersettings{'SMTP_SCAN_BLUE'}   eq 'on'    || 
                  $copfiltersettings{'SMTP_SCAN_RED'}    eq 'on' )))  {
			$copfiltersettings{'SPAMD_ENABLE'} = 'on';
			system ('/usr/bin/touch', "${copfilter_swroot}/etc/spamd_enable"); }


# if setting were valid, write settings and reconfigure

         &writehashsorted("${copfilter_swroot}/etc/global_settings", \%copfiltersettings);


        if ( ! ($copfiltersettings{'SKIP_RESTART'} eq 'on' )) {
            &copfilter_start_log(); 
            print "<br /><b>$Lang::tr{'copfilter restart0'} proxsmtpd..</b> <br />";
            system('/usr/local/bin/copfilter_restartproxsmtpd');
            print "<br /><b>$Lang::tr{'copfilter restart0'} monit..</b> <br />";
            system('/usr/local/bin/copfilter_restartmonit');
            &copfilter_stop_log(); 
        }
        else {
            $copfiltersettings{'ACTION'} = '';
        }

        }

        else {
            $copfiltersettings{'ACTION'} = '';
        }


}






################################################################################
##  Website - Information
################################################################################


#for testing purposes only
#&General::writehash("/tmp/settings", \%copfiltersettings);

if ($copfiltersettings{'ACTION'} eq '')
{

&Header::openbigbox('100%', 'left', '', $errormessage);


if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'copfilter error messages'});
    #print "<class name='base'><font color='${Header::colourred}'>$errormessage\n</font>";
    print "<font class='base'>$errormessage&nbsp;</font>\n";
    &Header::closebox();
}

##
## set some default values
##
if ($copfiltersettings{'SMTP_INT_PORT'} eq '') {
    $copfiltersettings{'SMTP_INT_PORT'} = '25';
}
if ($copfiltersettings{'SMTP_INT2_PORT'} eq '') {
    $copfiltersettings{'SMTP_INT2_PORT'} = '587';
}
if ($copfiltersettings{'SMTP_EXT_PORT'} eq '') {
    $copfiltersettings{'SMTP_EXT_PORT'} = '25';
}

################################################################################
##  Website - SMTP Scanning
################################################################################

my $output = `/etc/rc.d/init.d/copfilter_proxsmtpd pid weboutput`;
my $status = "";
if ( $output =~ /OFF/ ) { $status="<td width='180' height='20' bgcolor='#C01327' align='center' ><font color='#FFFFFF'size='2.7em'><b> STOPPED <\/b><\/font>"; }
if ( $output =~ /NOT ACTIVATED/ ) { $status="<td width='180' height='20' bgcolor='#A8A8A8' align='center' ><font size='2.7em'><b> NOT ACTIVATED <\/b><\/font>";; }
if ( $output =~ /ON/ ) { $status="<td width='180' height='20' bgcolor='#339933' align='center' ><font color='#FFFFFF' size='2.7em'><b> RUNNING <\/b><\/font>";; }

print "<a name='smtp'/>";
&Header::openbox('100%', 'left', "$Lang::tr{'copfilter smtp'} (ProxSMTP):");
print "<form method='post' action='/cgi-bin/copfilter_smtp.cgi' enctype='multipart/form-data'>";
print <<END

<table width='400'>
<tr>
    <td><font size='2.7em'><b>ProxSMTP Status:</b></td>
    $status
    <td colspan='2'>&nbsp;</td>
</tr>
</table>

<table border='0' cellpadding='5'>

<tr>
	<td width='300'> </td>
	<td width='100'></td>
	<td width='10'></td>
	<td width='300'></td>
	<td></td>
</tr>
<tr>
        <td> $Lang::tr{'copfilter smtp_scan_green'}</td>
        <td> <select name='SMTP_SCAN_GREEN'>
             <option value='on' $selected{'SMTP_SCAN_GREEN'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SCAN_GREEN'}{'off'}>off</option> </select></td>
	<td> </td>
        <td> $Lang::tr{'copfilter smtp_virscan'}</td>
        <td> <select name='SMTP_VIRUS_SCAN'>
             <option value='on' $selected{'SMTP_VIRUS_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_SCAN'}{'off'}>off</option> </select></td>


</tr>
<!--- set internal port --->
<tr>
        <td> $Lang::tr{'copfilter smtp_scan_intern_port_desc'} </td>
        <td> <input type='text' size="6" name='SMTP_INT_PORT' value='$copfiltersettings{'SMTP_INT_PORT'}' /> </td>
        <td> </td>
       
	<td> $Lang::tr{'copfilter smtp_attachment_virus_scan'}</td>
        <td> <select name='SMTP_VIRUS_SCAN_ATTACHMENT'> 
             <option value='on' $selected{'SMTP_VIRUS_SCAN_ATTACHMENT'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_SCAN_ATTACHMENT'}{'off'}>off</option> </select></td>

</tr>
<tr>
        <td> $Lang::tr{'copfilter smtp_scan_intern_port_desc'} </td>
        <td> <input type='text' size="6" name='SMTP_INT2_PORT' value='$copfiltersettings{'SMTP_INT2_PORT'}' /> </td>
        <td> </td>
        <td> <br /> </td>
        <td> <br /> </td>
</tr>
<td>$Lang::tr{'copfilter smtp_scan_intern_port'}/587 <font color='#993333'><b>*****</b></font></td>

<!--- set internal port --->
<tr>

END
;
if ($netsettings{'ORANGE_1_DEV'}) {
print <<END
        <td> $Lang::tr{'copfilter smtp_scan_orange'}</td>
        <td> <select name='SMTP_SCAN_ORANGE'>
             <option value='on' $selected{'SMTP_SCAN_ORANGE'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SCAN_ORANGE'}{'off'}>off</option> </select></td>
END
;
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
}
print <<END
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_spamscan'}</td>
        <td> <select name='SMTP_SPAM_SCAN'> 
             <option value='on' $selected{'SMTP_SPAM_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SPAM_SCAN'}{'off'}>off</option> </select></td>


</tr>
<tr>
END
;
if ($netsettings{'BLUE_1_DEV'}) {
print <<END
        <td> $Lang::tr{'copfilter smtp_scan_blue'}</td>
        <td> <select name='SMTP_SCAN_BLUE'>
             <option value='on' $selected{'SMTP_SCAN_BLUE'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SCAN_BLUE'}{'off'}>off</option> </select></td>
END
;
}
else {
print "<td> </td>\n";
print "<td> </td>\n";
}
print <<END



	<td> </td>
	<td> $Lang::tr{'copfilter smtp_attachmentscan'}</td>
        <td> <select name='SMTP_ATTACHMENT_SCAN'> 
             <option value='on' $selected{'SMTP_ATTACHMENT_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_ATTACHMENT_SCAN'}{'off'}>off</option> </select></td>

</tr>

<!-- remove this option, since it breaks jpg attachments
<tr>
	<td> </td>
	<td> </td>
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_anomyscan'}</td>
        <td> <select name='SMTP_SANITIZE_SCAN'> 
             <option value='on' $selected{'SMTP_SANITIZE_SCAN'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SANITIZE_SCAN'}{'off'}>off</option> </select></td>
</tr>
-->

<tr>
        <td>&nbsp;</td>
</tr>

<tr>
    <!--
    <td> $Lang::tr{'copfilter smtp_mail_rewrite_subject'}</td>
        <td> <select name='SMTP_MAIL_REWRITE_SUBJECT'> 
             <option value='on' $selected{'SMTP_MAIL_REWRITE_SUBJECT'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_MAIL_REWRITE_SUBJECT'}{'off'}>off</option> </select></td>
    -->
    <td> $Lang::tr{'copfilter smtp_mail_add_header'}</td>
        <td> <select name='SMTP_MAIL_ADD_HEADER'> 
             <option value='on' $selected{'SMTP_MAIL_ADD_HEADER'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_MAIL_ADD_HEADER'}{'off'}>off</option> </select></td>
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_virscan_quarantine_notify_user'}</td>
        <td> <select name='SMTP_VIRUS_NOTIFY_USER'> 
             <option value='on' $selected{'SMTP_VIRUS_NOTIFY_USER'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_NOTIFY_USER'}{'off'}>off</option> </select></td>
</tr>
<tr>
    <td> $Lang::tr{'copfilter smtp_mail_add_body'}</td>
        <td> <select name='SMTP_MAIL_ADD_BODY'> 
             <option value='on' $selected{'SMTP_MAIL_ADD_BODY'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_MAIL_ADD_BODY'}{'off'}>off</option> </select></td>
    <!--
	<td> </td>
	<td> </td>
    -->
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_virscan_adminnotif'}</td>
        <td> <select name='SMTP_VIRUS_ADMINNOTIF'> 
             <option value='on' $selected{'SMTP_VIRUS_ADMINNOTIF'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_ADMINNOTIF'}{'off'}>off</option> </select></td>
</tr>

<tr>
        <td><br /> <br /><br /></td>
</tr>

<tr>
        <td> $Lang::tr{'copfilter smtp_scan_red'}  <font color='#993333'><b>***</b></font></td>
        <td>  <select name='SMTP_SCAN_RED'>
             <option value='on' $selected{'SMTP_SCAN_RED'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SCAN_RED'}{'off'}>off</option> </select></td>
	<td> </td>
        <td> $Lang::tr{'copfilter smtp_virscan_discard'}</td>
        <td> <select name='SMTP_VIRUS_SCAN_DISCARD'>
             <option value='on' $selected{'SMTP_VIRUS_SCAN_DISCARD'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_SCAN_DISCARD'}{'off'}>off</option> </select></td>
</tr>
<!--- set external port --->
<tr>
        <td> $Lang::tr{'copfilter smtp_scan_extern_port_desc'} </td>
        <td> <input type='text' size="6" name='SMTP_EXT_PORT' value='$copfiltersettings{'SMTP_EXT_PORT'}' /> $Lang::tr{'copfilter smtp_scan_extern_port'} <font color='#993333'><b>*****</b></font></td>
        <td> </td>
        <td> &nbsp; </td>
        <td> &nbsp; </td>
</tr>
<!--- set external port --->
<tr>
        <td> $Lang::tr{'copfilter mail server location'}</td>
        <td>  <select name='MAIL_SRV_LOCATION'>
             <option value='GREEN' $selected{'MAIL_SRV_LOCATION'}{'GREEN'}>GREEN</option>
             <option value='ORANGE' $selected{'MAIL_SRV_LOCATION'}{'ORANGE'}>ORANGE</option> </select></td>
	<td> </td>
        <td> $Lang::tr{'copfilter smtp_spamscan_discard'}</td>
        <td> <select name='SMTP_SPAM_SCAN_DISCARD'> 
             <option value='on' $selected{'SMTP_SPAM_SCAN_DISCARD'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SPAM_SCAN_DISCARD'}{'off'}>off</option> </select></td>

</tr>
<tr>
        <td> $Lang::tr{'copfilter mail server'}</td>
        <td><input type='text' size="12" name='MAILSERVER' value='$copfiltersettings{'MAILSERVER'}' /> </td>
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_spamscan_discard_level'}</td>
	<td> <select name='SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'>
END
;
                for(my $i = $copfiltersettings{'SPAM_SCAN_SCORE_LEVEL'}; $i <= 40; $i++)
                {
                   print "<option value='$i' $selected{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}{$i}>$i</option>";
                }
print <<END

</select> </td>
</tr>

<tr>
        <td> $Lang::tr{'copfilter mail server port'}</td>
        <td><input type='text' size="2" name='MAILSERVER_PORT' value='$copfiltersettings{'MAILSERVER_PORT'}' /> </td>
	<td> </td>
        <td> $Lang::tr{'copfilter smtp_attachmentscan_discard'}</td>
        <td> <select name='SMTP_ATTACHMENT_SCAN_DISCARD'> 
             <option value='on' $selected{'SMTP_ATTACHMENT_SCAN_DISCARD'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_ATTACHMENT_SCAN_DISCARD'}{'off'}>off</option> </select></td>
</tr>

<tr>
        <td> $Lang::tr{'copfilter redip_alias'}</td>
        <td><input type='text' size="12" name='RED_IP_ALIAS' value='$copfiltersettings{'RED_IP_ALIAS'}' /> </td>
        <td> </td>
        <td> $Lang::tr{'copfilter reject_instead_of_discard_email'}</td>
        <td> <select name='REJECT_INSTEAD_OF_DISCARD_EMAIL'> 
             <option value='on' $selected{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}{'on'}>on</option>
             <option value='off' $selected{'REJECT_INSTEAD_OF_DISCARD_EMAIL'}{'off'}>off</option> </select></td>
</tr>

<tr>
        <td> $Lang::tr{'copfilter redip_alias_netmask'}</td>
        <td><input type='text' size="12" name='RED_IP_ALIAS_NETMASK' value='$copfiltersettings{'RED_IP_ALIAS_NETMASK'}' /> </td>
        <td> </td>
</tr>

<tr>
        <td> $Lang::tr{'copfilter redip_alias interface'}</td>
                <td> <select name='REDIP_ALIAS_ETHERNET_INTERFACE'>
END
;

        for(my $i = 0; $i < 31; $i++)
        {
            print "<option value='$i' $selected{'REDIP_ALIAS_ETHERNET_INTERFACE'}{$i}>$netsettings{'RED_1_DEV'}:$i";
            #system("/sbin/ifconfig $netsettings{'RED_DEV'}:3 |grep inet |/bin/sed -e 's/.*inet addr:\(.*\) B.*/\1/' ");
            print "</option>\n";
        }

print <<END

    </select> </td>
        <td> </td>
        <td> $Lang::tr{'copfilter allow mail from ip'}</td>
        <td><input type='text' size="12" name='ALLOW_MAIL_ONLY_FROM_IP' value='$copfiltersettings{'ALLOW_MAIL_ONLY_FROM_IP'}' /> </td>

</tr>



<!--
<tr>
      <td> $Lang::tr{'copfilter smtp_greylisting'}</td>
        <td> <select name='SMTP_GREYLISTING'>
             <option value='on' $selected{'SMTP_GREYLISTING'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_GREYLISTING'}{'off'}>off</option> </select></td>
        <td> </td>
        <td> $Lang::tr{'copfilter greylisting_relay'}</td>
        <td><input type='text' size="20" name='SMTP_GREY_RELAY' value='$copfiltersettings{'SMTP_GREY_RELAY'}' /> </td>
</tr>
-->

<tr>
        <td></td>
        <td></td>
        <td></td>
</tr>


<!--
<tr>
        <td> $Lang::tr{'copfilter smtp_greylisting'}</td>
        <td> <select name='SMTP_GREYLISTING'> 
             <option value='on' $selected{'SMTP_GREYLISTING'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_GREYLISTING'}{'off'}>off</option> </select></td>
</tr>
-->



<tr>
        <td><br /> <br /><br /> </td>
</tr>


<tr>
	<td> $Lang::tr{'copfilter whitelist outgoing email'} $Lang::tr{'copfilter whitelist'}</td>
        <td> <select name='WHITELIST_OUTGOING_EMAIL'> 
             <option value='on' $selected{'WHITELIST_OUTGOING_EMAIL'}{'on'}>on</option>
             <option value='off' $selected{'WHITELIST_OUTGOING_EMAIL'}{'off'}>off</option> </select></td>
        <td></td>
        <td>$Lang::tr{'copfilter wh_cmd_mode1'} $Lang::tr{'copfilter whitelist'} $Lang::tr{'copfilter wh_cmd_mode2'}</td>
        <td>
             <select name='CP_WH_CMD_MODE'>
             <option value='on' $selected{'CP_WH_CMD_MODE'}{'on'}>on</option>
             <option value='off' $selected{'CP_WH_CMD_MODE'}{'off'}>off</option> </select> </td>
</tr>

<tr>
	<td> $Lang::tr{'copfilter disable_spam_scanning'}</td>
        <td> <select name='DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'> 
             <option value='on' $selected{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}{'on'}>on</option>
             <option value='off' $selected{'DISABLE_SPAM_SCANNING_FROM_OUTGOING_MAIL'}{'off'}>off</option> </select></td>
	<td> </td>
	<td> $Lang::tr{'copfilter smtp spam whitelist'}</td>
        <td> <select name='SMTP_SPAM_WHITELIST'> 
             <option value='on' $selected{'SMTP_SPAM_WHITELIST'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SPAM_WHITELIST'}{'off'}>off</option> </select></td>
</tr>

<tr>
        <td><br /><br /><br /> </td>
</tr>

<tr>
	<td> $Lang::tr{'copfilter smtp_spamscan_quarantine'}</td>
        <td> <select name='SMTP_SPAM_QUARANTINE'> 
             <option value='on' $selected{'SMTP_SPAM_QUARANTINE'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SPAM_QUARANTINE'}{'off'}>off</option> </select></td>
	<td> </td>
	<td> $Lang::tr{'copfilter smtp_virscan_quarantine'}</td>
        <td> <select name='SMTP_VIRUS_QUARANTINE'> 
             <option value='on' $selected{'SMTP_VIRUS_QUARANTINE'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_VIRUS_QUARANTINE'}{'off'}>off</option> </select></td>
</tr>


<tr>
    <td>$Lang::tr{'copfilter smtp_spamscan_quarantine_level'}</td>
                <td colspan='2'> <select name='SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'>
END
;


        if  ($copfiltersettings{'SMTP_SPAM_SCAN_DISCARD'} eq 'on') {
             for(my $i = $copfiltersettings{'SPAM_SCAN_SCORE_LEVEL'}; $i < $copfiltersettings{'SMTP_SPAM_SCAN_DISCARD_SCORE_LEVEL'}; $i++)
             {
                print "<option value='$i' $selected{'SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'}{$i}>$i</option>";
             }
        }
        else {
             for(my $i = $copfiltersettings{'SPAM_SCAN_SCORE_LEVEL'}; $i < 40; $i++)
             {
                print "<option value='$i' $selected{'SMTP_SPAM_SCAN_QUARANTINE_SCORE_LEVEL'}{$i}>$i</option>";
             }

        }





print <<END
    </select> </td>
</tr>


<tr>
	<td> $Lang::tr{'copfilter smtp_spamscan_quarantine_notify_user'}</td>
        <td> <select name='SMTP_SPAM_QUARANTINE_NOTIFY_USER'> 
             <option value='on' $selected{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}{'on'}>on</option>
             <option value='off' $selected{'SMTP_SPAM_QUARANTINE_NOTIFY_USER'}{'off'}>off</option> </select></td>
	<td> </td>
        <td valign='top'> $Lang::tr{'copfilter remove infected mails after'} </td>
        <td valign='top'> <input type='text' name='SMTP_VIRUS_QUARANTINE_REMOVAL_DAYS' size='3' maxlength='3' value='$copfiltersettings{'SMTP_VIRUS_QUARANTINE_REMOVAL_DAYS'}' /></td>
</tr>

<tr>
	<td> $Lang::tr{'copfilter domains'}</td>
        <td> <input type='text' size="50" name='SMTP_DOMAIN' value='$copfiltersettings{'SMTP_DOMAIN'}' /></td>
</tr>

<tr>
        <td><br /><br /><br /> </td>
</tr>



<tr>
        <td colspan='5'>
                        $Lang::tr{'copfilter smtp spam whitelist2'}<br />
<!--                        <br />$Lang::tr{'copfilter smtp restart'} <br />$Lang::tr{'copfilter sanitizdes'} -->
                        $Lang::tr{'copfilter reject_instead_of_discard_email2'}<br />
                        <br />$Lang::tr{'copfilter smtp restart'}
                        <br /><font color='#993333'> <b>$Lang::tr{'copfilter open_port'} </b></font>
                       	<br />**** $Lang::tr{'copfilter whitelist outgoing email2'}
                       	<br />***** $Lang::tr{'copfilter whitelist outgoing email3'}
        </td>
        <td></td>
</tr>


<tr>
        <td colspan='3'>
            <input type='checkbox' name='SKIP_RESTART' />
             $Lang::tr{'copfilter skip restart'}
        </td>
</tr>

<tr>
        <td colspan='2'><input type='submit' name='ACTION' value='$Lang::tr{'copfilter save'}' /> </td>
        <td> </td>
</tr>

</table>

END
;

print "</form>\n";
&Header::closebox();
print "<br />";


# For Testing
#print "<pre>";
#$output = `cat /var/log/copfilter/default/etc/global_settings`;
#print "$output\n";
#print "</pre>";
&Header::closebigbox();

&Header::closepage();


}
